/*
    libresize 0.08
    Copyright (C) 1998-1999  Andrew Clausen  <clausen@alphalink.com.au>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    I can also be contacted at:

    Andrew Clausen
    18 Shaw St
    Ashwood, 3147
    Victoria, Australia

    Some of this code is from mkdosfs (Dave Hudson dave@humbug.demon.co.uk)
*/

#ifndef FATIO_H_INCLUDED
#define FATIO_H_INCLUDED

#include "libresize.h"

extern int
trimlib_seek_read (msdos_filesystem *fs, char *buf, off_t pos, cluster_t size);

extern int
trimlib_seek_write (msdos_filesystem *fs, char *buf, off_t pos, cluster_t size);

extern int
trimlib_read_clusters (msdos_filesystem *fs, char *buf, cluster_t cluster,
                       long count);

extern int
trimlib_write_clusters (msdos_filesystem *fs, char *buf, cluster_t cluster,
                        long count);

extern int
trimlib_read_cluster (msdos_filesystem *fs, char *buf, cluster_t cluster);

extern int
trimlib_write_cluster (msdos_filesystem *fs, char *buf, cluster_t cluster);

extern cluster_t
trimlib_get_fat (msdos_filesystem *fs, cluster_t cluster);

extern void
trimlib_set_fat (msdos_filesystem *fs, cluster_t cluster, cluster_t value);

extern cluster_t
get_free_cluster (msdos_filesystem *fs);

extern int
trimlib_check_mounted (msdos_filesystem *fs);

extern int
trimlib_is_bad (msdos_filesystem *fs, cluster_t cluster);

extern int
trimlib_is_eof (msdos_filesystem *fs, cluster_t cluster);

extern int
trimlib_is_empty (msdos_filesystem *fs, cluster_t cluster);

extern int
trimlib_is_avail (msdos_filesystem *fs, cluster_t cluster);

extern void
trimlib_set_eof (msdos_filesystem *fs, cluster_t cluster);

extern void
trimlib_set_avail (msdos_filesystem *fs, cluster_t cluster);

extern void
trimlib_error (msdos_filesystem *fs, char *format, ...);

extern int
trimlib_read_fat (msdos_filesystem *fs);

extern int
trimlib_write_fat (msdos_filesystem *fs);

extern int
trimlib_check_fat (msdos_filesystem *fs);

extern void
trimlib_clear_new_fat (msdos_filesystem *fs);

extern void
trimlib_use_new_fat (msdos_filesystem *fs);

extern cluster_t
trimlib_get_new_fat (msdos_filesystem *fs, cluster_t cluster);

extern void
trimlib_set_new_fat (msdos_filesystem *fs, cluster_t cluster, cluster_t value);

extern void
trimlib_set_new_avail (msdos_filesystem *fs, cluster_t cluster);

#endif /* FATIO_H_INCLUDED */
